<template>
  <div class="product-show">
    <v-content style="padding-top: 0px;">
      <v-container fluid>
        <div class="d-flex align-start">
          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="6"
            lg="6"
            xl="6"
            class="d-flex align-start justify-end"
          >
            <div class="d-flex align-start flex-column">
              <v-img
                v-for="(image, index) in product.images"
                :key="index"
                :src="getImage(image)"
                aspect-ratio="2"
                width="100"
                height="100"
                style="margin: 0px 15px 15px 15px;"
                contain
                @mouseover="changeImage(image)"
              ></v-img>
            </div>

            <div class="d-flex flex-column">
              <v-img :src="coverImg" aspect-ratio="2" width="600" height="800" contain></v-img>

              <p>{{product.numProduct}}</p>

              <i>
                Produit disponible au Magasin:
                {{product.store.street}}, {{product.store.city}}, {{product.store.zc}} - {{product.store.city}}, {{product.store.country}}
              </i>
            </div>
          </v-col>

          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="6"
            lg="6"
            xl="6"
            class="d-flex align-start justify-start"
          >
            <div class="d-flex align-start flex-column" style="width: 100%;">
              <v-col cols="12" xs="12" sm="12" md="8" lg="8" xl="8">
                <div class="headline font-weight-bold mb-3">
                  <h2>{{product['name']}}</h2>
                </div>

                <div class="d-flex flex-column mb-5">
                  <div v-if="nbComments" class="body-2">
                    <span>
                      Noté
                      <star-rating
                        :inline="true"
                        :star-size="20"
                        :read-only="true"
                        :show-rating="false"
                        :rating="product['notation']"
                        :round-start-rating="false"
                      ></star-rating>
                      par les utilisateurs sur un total de {{nbComments}}
                    </span>
                  </div>
                  <div v-else class="body-2">
                    <span>Aucune note sur ce produit. Soyez le premier à commenter !</span>
                  </div>
                  <a href="#ajouter-un-com" class="caption">Ajouter un commentaire</a>
                </div>

                <div class="headline font-weight-bold mb-3">
                  <h3>{{product['price']}} €</h3>

                  <div class="mt-2">Caution: {{product.caution !== undefined ? item.caution : 0}}€</div>
                </div>
              </v-col>

              <v-col
                cols="12"
                xs="12"
                sm="12"
                md="8"
                lg="8"
                xl="8"
                class="d-flex align-start justify-start"
              >
                <div class="mb-3">
                  <span>{{product['description']}}</span>
                </div>
              </v-col>

              <v-col cols="12" xs="12" sm="12" md="8" lg="8" xl="8">
                <div v-if="userData">
                  <div class="mb-3">
                    <div v-if="checkAdded() == true">
                      <v-btn
                        color="red"
                        @click="removeCart()"
                        class="mb-2 mb-sm-0"
                        style="color: white;"
                      >
                        <v-icon style="text-decoration: none;">mdi-cart-remove</v-icon>Retirer
                      </v-btn>
                    </div>

                    <div v-else>
                      <v-btn
                        color="orange"
                        @click="addCart()"
                        class="mb-2 mb-sm-0"
                        style="color: white;"
                      >
                        <v-icon style="text-decoration: none;">mdi-cart-plus</v-icon>Panier
                      </v-btn>
                    </div>
                  </div>
                </div>

                <div class="d-flex flex-column" v-else>
                  <v-btn
                    disabled
                    color="orange"
                    class="mb-2 mb-sm-0"
                    style="color: white; width: 25%;"
                  >
                    <v-icon style="text-decoration: none;">mdi-cart-plus</v-icon>Panier
                  </v-btn>
                  <i
                    style="font-size: 0.85em;"
                  >Veuillez vous connectez pour ajouter ce produit au panier.</i>
                </div>

                <div class="d-flex align-center mt-3">
                  <v-btn icon color="primary">
                    <a
                      :href="`https://www.facebook.com/sharer/sharer.php?u=${currentLocation}`"
                      target="_blank"
                      style="text-decoration: none;"
                    >
                      <v-icon>mdi-facebook</v-icon>
                    </a>
                  </v-btn>

                  <v-btn icon color="blue lighten-2">
                    <a
                      :href="`https://twitter.com/intent/tweet?url=${currentLocation}`"
                      target="_blank"
                      style="text-decoration: none;"
                    >
                      <v-icon>mdi-twitter</v-icon>
                    </a>
                  </v-btn>
                </div>
              </v-col>
            </div>
          </v-col>
        </div>

        <v-row>
          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="5"
            lg="5"
            xl="5"
            offset-md="1"
            offset-lg="1"
            offset-xl="1"
          >
            <h2>Commentaires</h2>
          </v-col>
        </v-row>

        <v-row>
          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="5"
            lg="5"
            xl="5"
            offset-md="1"
            offset-lg="1"
            offset-xl="1"
            class="d-flex align-start justify-start"
          >
            <CommentList v-bind:comments="product.comments" />
          </v-col>

          <v-col
            cols="12"
            xs="12"
            sm="12"
            md="6"
            lg="6"
            xl="6"
            class="d-flex align-start justify-start"
            id="ajouter-un-com"
          >
            <CommentCreate v-bind:user="userData" v-bind:product="product" />
          </v-col>
        </v-row>
      </v-container>
    </v-content>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";
import CommentList from "../comment/List";
import CommentCreate from "../comment/Create";
import StarRating from "vue-star-rating";
import { ENTRYPOINT } from "../../config/entrypoint";

const servicePrefix = "Product";

export default {
  name: "ProductShow",
  servicePrefix,
  components: {
    CommentList,
    CommentCreate,
    StarRating
  },
  data() {
    return {
      currentLocation: window.location.href,
      quantite: "",
      jourLocation: "",
      coverImg: "",
      userData: JSON.parse(localStorage.getItem("user")),
      isIn: false
    };
  },
  watch: {
    productLoaded(val) {
      if (val == true) {
        if(this.product.images.length > 0){
          this.coverImg = ENTRYPOINT + '/media/' + this.product.images[0].filePath
        }
      }
    }
  },
  computed: {
    ...mapFields("product", {
      product: "product",
      productLoaded: "productLoaded"
    }),
    ...mapFields("cart", {
      cart: "cart"
    }),
    nbComments: function() {
      let nbComments = 0;
      let com = " commentaires.";
      this.product.comments.map(() => {
        nbComments = nbComments + 1;
      });
      if (nbComments == 1) {
        com = " commentaire.";
      } else if (nbComments == 0) {
        return false;
      }
      return nbComments + com;
    }
  },
  methods: {
    getImage(image) {
      return ENTRYPOINT + "/media/" + image.filePath;
    },
    ...mapActions('product', ['getProduct']),
    ...mapActions('cart', ['getCartProduct', 'addProductCart', 'removeProductCart']),
    addCart: function(){
      this.addProductCart({productId: this.product.id, cartId: this.cart.id});
      setTimeout(() => this.getProduct(location.pathname.split('/')[2]), 500);
    },
    removeCart: function() {
      this.removeProductCart({
        productId: this.product.id,
        cartId: this.cart.id
      });
      setTimeout(() => this.getProduct(location.pathname.split("/")[2]), 500);
    },
    changeImage: function(newImage) {
      this.coverImg = ENTRYPOINT + "/media/" + newImage.filePath;
    },
    checkAdded: function() {
      var isIn = false;
      var productId = this.product.id;
      if (this.cart.cartProducts !== undefined) {
        if (this.cart.cartProducts.length > 0) {
          this.cart.cartProducts.map(function(value) {
            if (value.product.id == productId && isIn == false) {
              isIn = true;
            }
          });
        }
      }
      return isIn;
    }
  },
  mounted: function () {
    this.$nextTick(function () {
      this.getProduct(location.pathname.split('/')[2]);
      this.getCartProduct();
    })
  },
};
</script>

<style scoped>
.v-image {
  cursor: pointer;
}
</style>
